import nsrunit;
unit conversion on;
unit kPa=1E3 kilogram^1*meter^(-1)*second^(-2);
unit mL=1E-6 meter^3;
unit per_mL=1E6 meter^(-3);
unit kPa_per_mL=1E9 kilogram^1*meter^(-4)*second^(-2);
unit kPa_second_per_mL=1E9 kilogram^1*meter^(-4)*second^(-1);
unit mL_per_second=1E-6 meter^3*second^(-1);
unit mL_per_second2=1E-6 meter^3*second^(-2);
unit per_second2=1 second^(-2);
unit kPa_second2_per_mL=1E9 kilogram^1*meter^(-4);

math main {
	realDomain time second;
	time.min=0;
	extern time.max;
	extern time.delta;
	real R_mt kPa_second_per_mL;
	R_mt=0.0158;
	real R_av kPa_second_per_mL;
	R_av=0.0180;
	real R_tc kPa_second_per_mL;
	R_tc=0.0237;
	real R_pv kPa_second_per_mL;
	R_pv=0.0055;
	real R_pul kPa_second_per_mL;
	R_pul=0.1552;
	real R_sys kPa_second_per_mL;
	R_sys=1.0889;
	real L_tc kPa_second2_per_mL;
	L_tc=8.0093e-5;
	real L_pv kPa_second2_per_mL;
	L_pv=1.4868e-4;
	real L_mt kPa_second2_per_mL;
	L_mt=7.6968e-5;
	real L_av kPa_second2_per_mL;
	L_av=1.2189e-4;
	real V_tot mL;
	V_tot=1.5;
	real P_th kPa;
	P_th=-4;
	real e_t(time) dimensionless;
	real A dimensionless;
	A=1;
	real B per_second2;
	B=80;
	real C second;
	C=0.375;
	real tau(time) second;
	real period second;
	period=0.75;
	real V_pcd(time) mL;
	real P_pcd(time) kPa;
	real P_peri(time) kPa;
	real V_lv(time) mL;
	when(time=time.min) V_lv=94.6812;
	real V_rv(time) mL;
	when(time=time.min) V_rv=90.7302;
	real P_0_pcd kPa;
	P_0_pcd=0.5003;
	real V_0_pcd mL;
	V_0_pcd=200;
	real lambda_pcd per_mL;
	lambda_pcd=0.03;
	real V_lvf(time) mL;
	real P_lvf(time) kPa;
	real P_lv(time) kPa;
	real V_spt(time) mL;
	real P_es_lvf(time) kPa;
	real P_ed_lvf(time) kPa;
	real P_pu(time) kPa;
	real P_ao(time) kPa;
	real E_es_lvf kPa_per_mL;
	E_es_lvf=2.8798;
	real lambda_lvf per_mL;
	lambda_lvf=0.033;
	real P_0_lvf kPa;
	P_0_lvf=0.1203;
	real Q_mt(time) mL_per_second;
	when(time=time.min) Q_mt=245.5813;
	real Q_av(time) mL_per_second;
	when(time=time.min) Q_av=0;
	real V_d_lvf mL;
	V_d_lvf=0;
	real V_0_lvf mL;
	V_0_lvf=0;
	real V_rvf(time) mL;
	real P_rvf(time) kPa;
	real P_rv(time) kPa;
	real P_es_rvf(time) kPa;
	real P_ed_rvf(time) kPa;
	real P_pa(time) kPa;
	real P_vc(time) kPa;
	real E_es_rvf kPa_per_mL;
	E_es_rvf=0.585;
	real lambda_rvf per_mL;
	lambda_rvf=0.023;
	real P_0_rvf kPa;
	P_0_rvf=0.2157;
	real Q_tc(time) mL_per_second;
	when(time=time.min) Q_tc=190.0661;
	real Q_pv(time) mL_per_second;
	when(time=time.min) Q_pv=0;
	real V_d_rvf mL;
	V_d_rvf=0;
	real V_0_rvf mL;
	V_0_rvf=0;
	real E_es_spt kPa_per_mL;
	E_es_spt=48.754;
	real V_d_spt mL;
	V_d_spt=2;
	real P_0_spt kPa;
	P_0_spt=1.1101;
	real lambda_spt per_mL;
	lambda_spt=0.435;
	real V_0_spt mL;
	V_0_spt=2;
	real one dimensionless;
	one=1;
	real E_es_pa kPa_per_mL;
	E_es_pa=0.369;
	real V_pa(time) mL;
	when(time=time.min) V_pa=43.0123;
	real V_d_pa mL;
	V_d_pa=0;
	real Q_pul(time) mL_per_second;
	real E_es_pu kPa_per_mL;
	E_es_pu=0.0073;
	real V_pu(time) mL;
	when(time=time.min) V_pu=808.4579;
	real V_d_pu mL;
	V_d_pu=0;
	real E_es_ao kPa_per_mL;
	E_es_ao=0.6913;
	real V_ao(time) mL;
	when(time=time.min) V_ao=133.3381;
	real V_d_ao mL;
	V_d_ao=0;
	real Q_sys(time) mL_per_second;
	real E_es_vc kPa_per_mL;
	E_es_vc=0.0059;
	real V_vc(time) mL;
	when(time=time.min) V_vc=329.7803;
	real V_d_vc mL;
	V_d_vc=0;
	real v_to(time) mL;

	// <component name="environment">

	// <component name="heart_parameters">

	// <component name="driver_function">
	tau=(time-floor(time/period)*period);
	e_t=(A*exp((-1)*B*(tau-C)^2));

	// <component name="pericardium">
	V_pcd=(V_lv+V_rv);
	P_pcd=(P_0_pcd*(exp(lambda_pcd*(V_pcd-V_0_pcd))-1));
	P_peri=(P_pcd+P_th);

	// <component name="left_ventricle">
	V_lvf=(V_lv-V_spt);
	P_lvf=(e_t*P_es_lvf+(1-e_t)*P_ed_lvf);
	P_lv=(P_lvf+P_peri);
	V_lv:time=(if ((Q_mt<(0 mL_per_second)) and (Q_av<(0 mL_per_second))) (0 mL_per_second) else if (Q_mt<(0 mL_per_second)) (-1)*Q_av else if (Q_av<(0 mL_per_second)) Q_mt else Q_mt-Q_av);

	// <component name="lvf_calculator">
	P_es_lvf=(E_es_lvf*(V_lvf-V_d_lvf));
	P_ed_lvf=(P_0_lvf*(exp(lambda_lvf*(V_lvf-V_0_lvf))-1));

	// <component name="right_ventricle">
	V_rvf=(V_rv+V_spt);
	P_rvf=(e_t*P_es_rvf+(1-e_t)*P_ed_rvf);
	P_rv=(P_rvf+P_peri);
	V_rv:time=(if ((Q_tc<(0 mL_per_second)) and (Q_pv<(0 mL_per_second))) (0 mL_per_second) else if (Q_tc<(0 mL_per_second)) (-1)*Q_pv else if (Q_pv<(0 mL_per_second)) Q_tc else Q_tc-Q_pv);

	// <component name="rvf_calculator">
	P_es_rvf=(E_es_rvf*(V_rvf-V_d_rvf));
	P_ed_rvf=(P_0_rvf*(exp(lambda_rvf*(V_rvf-V_0_rvf))-1));

	// <component name="septum">
	0=(e_t*E_es_spt*(V_spt-V_d_spt)+(one-e_t)*P_0_spt*(exp(lambda_spt*(V_spt-V_0_spt))-one)-e_t*E_es_lvf*(V_lv-V_spt)-(1-e_t)*P_0_lvf*(exp(lambda_lvf*(V_lv-V_spt))-1)+e_t*E_es_rvf*(V_rv+V_spt)+(1-e_t)*P_0_rvf*(exp(lambda_rvf*(V_rv+V_spt))-1));

	// <component name="pulmonary_artery">
	P_pa=(E_es_pa*(V_pa-V_d_pa)+P_th);
	V_pa:time=(if (Q_pv<(0 mL_per_second)) (-1)*Q_pul else Q_pv-Q_pul);

	// <component name="pulmonary_vein">
	P_pu=(E_es_pu*(V_pu-V_d_pu)+P_th);
	V_pu:time=(if (Q_mt<(0 mL_per_second)) Q_pul else Q_pul-Q_mt);

	// <component name="aorta">
	P_ao=(E_es_ao*(V_ao-V_d_ao));
	V_ao:time=(if (Q_av<(0 mL_per_second)) (-1)*Q_sys else Q_av-Q_sys);

	// <component name="vena_cava">
	P_vc=(E_es_vc*(V_vc-V_d_vc));
	V_vc:time=(if (Q_tc<(0 mL_per_second)) Q_sys else Q_sys-Q_tc);

	// <component name="flow">
	Q_sys=((P_ao-P_vc)/R_sys);
	Q_pul=((P_pa-P_pu)/R_pul);
	Q_mt:time=(if (((P_pu-P_lv)<(0 kPa)) and (Q_mt<(0 mL_per_second))) (0 mL_per_second2) else (P_pu-P_lv-Q_mt*R_mt)/L_mt);
	Q_av:time=(if (((P_lv-P_ao)<(0 kPa)) and (Q_av<(0 mL_per_second))) (0 mL_per_second2) else (P_lv-P_ao-Q_av*R_av)/L_av);
	Q_tc:time=(if (((P_vc-P_rv)<(0 kPa)) and (Q_tc<(0 mL_per_second))) (0 mL_per_second2) else (P_vc-P_rv-Q_tc*R_tc)/L_tc);
	Q_pv:time=(if (((P_rv-P_pa)<(0 kPa)) and (Q_pv<(0 mL_per_second))) (0 mL_per_second2) else (P_rv-P_pa-Q_pv*R_pv)/L_pv);

	// <component name="Total_volume">
	v_to=(V_lv+V_rv+V_ao+V_vc+V_pu+V_pa);
}
